OpenTTD Source: SpecializedStation< T, Tis_waypoint > Struct Template Reference

OpenTTD Source 14.1

Public Member Functions | Static Public Member Functions | Static Public Attributes
SpecializedStation< T, Tis_waypoint > Struct Template Reference

Class defining several overloaded accessors so we don't have to cast base stations that often. More...

`#include <base_station_base.h>`

Inheritance diagram for SpecializedStation< T, Tis_waypoint >:

## Public Member Functions
| SpecializedStation (TileIndex tile)
| Set station type correctly. More...
Public Member Functions inherited from BaseStation
| BaseStation (TileIndex tile)
| Initialize the base station. More...
virtual bool | TileBelongsToRailStation (TileIndex tile) const =0
| Check whether a specific tile belongs to this station. More...
virtual uint32_t | GetNewGRFVariable (const struct ResolverObject &object, byte variable, byte parameter, bool *available) const =0
| Helper function to get a NewGRF variable that isn't implemented by the base class. More...
virtual void | UpdateVirtCoord ()=0
| Update the coordinated of the sign (as shown in the viewport).
const std::string & | GetCachedName () const
virtual void | MoveSign (TileIndex new_xy)
virtual void | GetTileArea (TileArea *ta, StationType type) const =0
| Get the tile area for a given station type. More...
virtual uint | GetPlatformLength (TileIndex tile) const =0
| Obtain the length of a platform. More...
virtual uint | GetPlatformLength (TileIndex tile, DiagDirection dir) const =0
| Determines the REMAINING length of a platform, starting at (and including) the given tile. More...
bool | IsInUse () const
| Check whether the base station currently is in use; in use means that it is not scheduled for deletion and that it still has some facilities left. More...
byte | GetRoadStopRandomBits (TileIndex tile) const
byte | GetRoadStopAnimationFrame (TileIndex tile) const
void | SetRoadStopRandomBits (TileIndex tile, byte random_bits)
void | SetRoadStopAnimationFrame (TileIndex tile, byte frame)
void | RemoveRoadStopTileData (TileIndex tile)
Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_station_pool >
void * | operator new (size_t size)
| Allocates space for new Titem. More...
void * | operator new (size_t size, size_t index)
| Allocates space for new Titem with given index. More...
void * | operator new (size_t, void *ptr)
| Allocates space for new Titem at given memory address. More...
void | operator delete (void *p)
| Marks Titem as free. More...

## Static Public Member Functions
static bool | IsExpected (const BaseStation *st)
| Helper for checking whether the given station is of this type. More...
static bool | IsValidID (size_t index)
| Tests whether given index is a valid index for station of this type. More...
static T * | Get (size_t index)
| Gets station with given index. More...
static T * | GetIfValid (size_t index)
| Returns station if the index is a valid index for this station type. More...
static T * | GetByTile (TileIndex tile)
| Get the station belonging to a specific tile. More...
static T * | From (BaseStation *st)
| Converts a BaseStation to SpecializedStation with type checking. More...
static const T * | From (const BaseStation *st)
| Converts a const BaseStation to const SpecializedStation with type checking. More...
static Pool::IterateWrapper< T > | Iterate (size_t from=0)
| Returns an iterable ensemble of all valid stations of type T. More...
Static Public Member Functions inherited from BaseStation
static BaseStation * | GetByTile (TileIndex tile)
| Get the base station belonging to a specific tile. More...
static void | PostDestructor (size_t index)
| Invalidating of the JoinStation window has to be done after removing item from the pool.
Static Public Member Functions inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_station_pool >
static bool | CanAllocateItem (size_t n=1)
| Helper functions so we can use PoolItem::Function() instead of _poolitem_pool.Function() More...
static bool | CleaningPool ()
| Returns current state of pool cleaning - yes or no. More...
static bool | IsValidID (size_t index)
| Tests whether given index can be used to get valid (non-nullptr) Titem. More...
static Titem * | Get (size_t index)
| Returns Titem with given index. More...
static Titem * | GetIfValid (size_t index)
| Returns Titem with given index. More...
static size_t | GetPoolSize ()
| Returns first unused index. More...
static size_t | GetNumItems ()
| Returns number of valid items in the pool. More...
static void | PostDestructor ([[maybe_unused]] size_t index)
| Dummy function called after destructor of each member. More...
static Pool::IterateWrapper< Titem > | Iterate (size_t from=0)
| Returns an iterable ensemble of all valid Titem. More...

## Static Public Attributes
static const StationFacility | EXPECTED_FACIL = Tis_waypoint ? FACIL_WAYPOINT : FACIL_NONE
| Specialized type.

## Additional Inherited Members
Public Types inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_station_pool >
typedef struct Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero > | Pool
| Type of the pool this item is going to be part of.
Data Fields inherited from BaseStation
TileIndex | xy
| Base tile of the station.
TrackedViewportSign | sign
| NOSAVE: Dimensions of sign.
byte | delete_ctr
| Delete counter. If greater than 0 then it is decremented until it reaches 0; the waypoint is then is deleted.
std::string | name
| Custom name.
StringID | string_id
| Default name (town area) of station.
std::string | cached_name
| NOSAVE: Cache of the resolved name of the station, if not using a custom name.
Town * | town
| The town this station is associated with.
Owner | owner
| The owner of this station.
StationFacility | facilities
| The facilities that this station has.
std::vector< StationSpecList > | speclist
| List of rail station specs of this station.
std::vector< RoadStopSpecList > | roadstop_speclist
| List of road stop specs of this station.
TimerGameCalendar::Date | build_date
| Date of construction.
uint16_t | random_bits
| Random bits assigned to this station.
byte | waiting_triggers
| Waiting triggers (NewGRF) for this station.
uint8_t | cached_anim_triggers
| NOSAVE: Combined animation trigger bitmask, used to determine if trigger processing should happen.
uint8_t | cached_roadstop_anim_triggers
| NOSAVE: Combined animation trigger bitmask for road stops, used to determine if trigger processing should happen.
CargoTypes | cached_cargo_triggers
| NOSAVE: Combined cargo trigger bitmask.
CargoTypes | cached_roadstop_cargo_triggers
| NOSAVE: Combined cargo trigger bitmask for road stops.
TileArea | train_station
| Tile area the train 'station' part covers.
StationRect | rect
| NOSAVE: Station spread out rectangle maintained by StationRect::xxx() functions.
std::vector< RoadStopTileData > | custom_roadstop_tile_data
| List of custom road stop tile data.
Data Fields inherited from Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_station_pool >
Tindex | index
| Index of this pool item.

## Detailed Description

### template<class T, bool Tis_waypoint>
struct SpecializedStation< T, Tis_waypoint >

Class defining several overloaded accessors so we don't have to cast base stations that often.

Definition at line 222 of file base_station_base.h.

## Constructor & Destructor Documentation

## ◆ SpecializedStation()

template<class T , bool Tis_waypoint>

SpecializedStation< T, Tis_waypoint >::SpecializedStation | ( | TileIndex | tile | ) |
| inline

Set station type correctly.

Parameters

  tile | The base tile of the station.

Definition at line 229 of file base_station_base.h.

## Member Function Documentation

## ◆ From() [1/2]

template<class T , bool Tis_waypoint>

static T* SpecializedStation< T, Tis_waypoint >::From | ( | BaseStation * | st | ) |
| inlinestatic

Converts a BaseStation to SpecializedStation with type checking.

Parameters

  st | BaseStation pointer

Returns
  pointer to SpecializedStation

Definition at line 288 of file base_station_base.h.

## ◆ From() [2/2]

template<class T , bool Tis_waypoint>

static const T* SpecializedStation< T, Tis_waypoint >::From | ( | const BaseStation * | st | ) |
| inlinestatic

Converts a const BaseStation to const SpecializedStation with type checking.

Parameters

  st | BaseStation pointer

Returns
  pointer to SpecializedStation

Definition at line 299 of file base_station_base.h.

## ◆ Get()

template<class T , bool Tis_waypoint>

static T* SpecializedStation< T, Tis_waypoint >::Get | ( | size_t | index | ) |
| inlinestatic

Gets station with given index.

Returns
  pointer to station with given index casted to T *

Definition at line 259 of file base_station_base.h.

## ◆ GetByTile()

template<class T , bool Tis_waypoint>

static T* SpecializedStation< T, Tis_waypoint >::GetByTile | ( | TileIndex | tile | ) |
| inlinestatic

Get the station belonging to a specific tile.

Parameters

  tile | The tile to get the station from.

Returns
  the station associated with that tile.

Definition at line 278 of file base_station_base.h.

## ◆ GetIfValid()

template<class T , bool Tis_waypoint>

static T* SpecializedStation< T, Tis_waypoint >::GetIfValid | ( | size_t | index | ) |
| inlinestatic

Returns station if the index is a valid index for this station type.

Returns
  pointer to station with given index if it's a station of this type

Definition at line 268 of file base_station_base.h.

## ◆ IsExpected()

template<class T , bool Tis_waypoint>

static bool SpecializedStation< T, Tis_waypoint >::IsExpected | ( | const BaseStation * | st | ) |
| inlinestatic

Helper for checking whether the given station is of this type.

Parameters

  st | the station to check.

Returns
  true if the station is the type we expect it to be.

Definition at line 240 of file base_station_base.h.

Referenced by SpecializedStation< Waypoint, true >::IsValidID().

## ◆ IsValidID()

template<class T , bool Tis_waypoint>

static bool SpecializedStation< T, Tis_waypoint >::IsValidID | ( | size_t | index | ) |
| inlinestatic

Tests whether given index is a valid index for station of this type.

Parameters

  index | tested index

Returns
  is this index valid index of T?

Definition at line 250 of file base_station_base.h.

## ◆ Iterate()

template<class T , bool Tis_waypoint>

static Pool::IterateWrapper<T> SpecializedStation< T, Tis_waypoint >::Iterate | ( | size_t | from = `0` | ) |
| inlinestatic

Returns an iterable ensemble of all valid stations of type T.

Parameters

  from | index of the first station to consider

Returns
  an iterable ensemble of all valid stations of type T

Definition at line 310 of file base_station_base.h.

The documentation for this struct was generated from the following file:

- src/base_station_base.h